;Environmental Bump Mapping sample
;By XoreX for Boolean.Name
;16.10.13

Include "DevilShadowSystem.bb"
Include "ShadowVolumes.bb"
Include "UserInterface.bb"

Function cameramove()
 mmx# = -MouseXSpeed() / 3.0
 mmy# = MouseYSpeed() / 3.0
 RotateEntity camera, EntityPitch(camera) + mmy, EntityYaw(camera) + mmx, 0
 MoveMouse 400,300
 If KeyDown(17) Then MoveEntity camera,0,0,.1
 If KeyDown(31) Then MoveEntity camera,0,0,-0.1
 If KeyDown(30) Then MoveEntity camera,-.1,0,0
 If KeyDown(32) Then MoveEntity camera,.1,0,0    
End Function



Graphics3D 800,600
SetBuffer BackBuffer()



Global camera = CreateCamera()
 InitShadows(camera)
 PositionEntity camera,2,1,2
Global light = CreateShadowLight(True)
 PointEntity light,CreatePivot()
 PositionEntity light,0,4,0
Global c = CreateShadowSphere(8)
 tex = LoadTexture("Swift2.jpg",64)
  ScaleTexture tex,.2,.2
 Bumpmap = LoadTexture("bumpmap.bmp")
  ScaleTexture bumpmap,.3,.3
 ScaleEntity c,5,5,5

 SetENBMMesh(c ,tex ,Bumpmap )
 
 
cube = CreateCube()
 ScaleEntity cube,15,8,15
  FlipMesh cube
 tex = LoadTexture("woodpanel.jpg")
 Bumpmap = LoadTexture("woodpanel_bump.jpg")
  ScaleTexture bumpmap,.2,.2
 SetShadowMesh(cube,False)
 SetENBMMesh(cube,tex,Bumpmap)
 


 SetENBMHeight(.8)

While Not KeyHit(1)

 TurnEntity c,.2,.2,.2

 cameramove()

 Render(1)
 Flip
 Delay(1)
Wend
End